Formulas

TableSheet supports some built-in formulas that can be used with hierarchy data.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children.

This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving.

The hierarchy summary field options:

interface GC.Data.IDataSourceOption {
    //others options...
    schema?: {
        hierarchy: {
          summaryFields: GC.Data.IHierarchySummaryFieldCollection // define the formulas for the fields
          //others options...
        }
        //others options...
    }
}
interface GC.Data.IHierarchySummaryFieldCollection {
    [key: string]: string; // the key is the field name, and the value is the formula
}

The following is a sample that shows how to configure the hierarchy summary fields:

var table = dataManager.addTable("Table", {
    schema: {
        hierarchy: {
            type: 'Parent',
            column: 'parent',
            summaryFields: {
                'budget':'=SUM(CHILDREN(1,"budget"))'
            }
        },
        columns: {
            id: {
                isPrimaryKey: true,
            },
            budget: { dataType: 'number' }
        },
    }
});
var view = table.addView("View",[
    { value: "id" },
    { value: "budget" },
])

The Built-in Formulas

The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy:

CHILDREN

This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent.

If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents.

CHILDREN(levelOffset, fieldName)

ONLYCHILDREN

This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents.

ONLYCHILDREN(fieldName)

PARENT

This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record.

If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved.

PARENT(levelOffset, fieldName)

LEVEL

This formula is for retrieving the level of the current record.

LEVEL()

LEVELROWNUMBER

This formula is for retrieving the row number of the current record under the parent scope.

LEVELROWNUMBER()
When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children. This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving. The hierarchy summary field options: The following is a sample that shows how to configure the hierarchy summary fields: The Built-in Formulas The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy: CHILDREN This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent. If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents. ONLYCHILDREN This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents. PARENT This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record. If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved. LEVEL This formula is for retrieving the level of the current record. LEVELROWNUMBER This formula is for retrieving the row number of the current record under the parent scope.
window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 0 }); initSpread(spread); }; function initSpread(spread) { spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.clearSheets(); var dataManager = spread.dataManager(); initHierarchyFormulas(spread, dataManager); } function initHierarchyFormulas(spread, dataManager) { var table = dataManager.addTable("Table", { remote: { read: { url: getBaseApiUrl() + "/Hierarchy_Formula" } }, schema: { hierarchy: { type: 'Parent', column: 'parent', summaryFields: { 'budget':'=SUM(CHILDREN(1,"budget"))' } }, columns: { id: { isPrimaryKey: true, }, }, } }); var sheet = spread.addSheetTab(0, "HierarchyFormula", GC.Spread.Sheets.SheetType.tableSheet); sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader); sheet.options.allowAddNew = false; table.fetch().then(function () { var myView = table.addView("myView", [ { value: '=CONCAT([@department]," (L",LEVEL(),"-",LEVELROWNUMBER(),")")', caption: 'Department', width: 265, outlineColumn: true }, { value: "budget", width: 100, caption: 'Budget' }, { value: '=IF(LEVEL()=0,"",[@budget]/PARENT(1,"budget"))', width: 120, caption: 'Percentage', style: { formatter: '0.00%' } }, { value: "location", width: 100, caption: 'Location' }, { value: "phone", width: 150, caption: 'Phone' }, { value: "country", width: 100, caption: 'Country' }, ]); spread.suspendPaint(); sheet.setDataView(myView); spread.resumePaint(); }); } function _getElementById(id) { return document.getElementById(id); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> </div></body> </html>
.colorLabel { background-color: #F4F8EB; } .rightAlignLabel { width: 120px; text-align: right; margin-right: 8px; } input[type="text"] { width: 190px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { margin-bottom: 6px; } input { padding: 4px 6px; } input[type=button] { margin-top: 6px; width: 190px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Formulas

TableSheet supports some built-in formulas that can be used with hierarchy data.

Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children.

This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving.

The hierarchy summary field options:

interface GC.Data.IDataSourceOption {
    //others options...
    schema?: {
        hierarchy: {
          summaryFields: GC.Data.IHierarchySummaryFieldCollection // define the formulas for the fields
          //others options...
        }
        //others options...
    }
}
interface GC.Data.IHierarchySummaryFieldCollection {
    [key: string]: string; // the key is the field name, and the value is the formula
}

The following is a sample that shows how to configure the hierarchy summary fields:

var table = dataManager.addTable("Table", {
    schema: {
        hierarchy: {
            type: 'Parent',
            column: 'parent',
            summaryFields: {
                'budget':'=SUM(CHILDREN(1,"budget"))'
            }
        },
        columns: {
            id: {
                isPrimaryKey: true,
            },
            budget: { dataType: 'number' }
        },
    }
});
var view = table.addView("View",[
    { value: "id" },
    { value: "budget" },
])

The Built-in Formulas

The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy:

CHILDREN

This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent.

If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents.

CHILDREN(levelOffset, fieldName)

ONLYCHILDREN

This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents.

ONLYCHILDREN(fieldName)

PARENT

This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record.

If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved.

PARENT(levelOffset, fieldName)

LEVEL

This formula is for retrieving the level of the current record.

LEVEL()

LEVELROWNUMBER

This formula is for retrieving the row number of the current record under the parent scope.

LEVELROWNUMBER()
When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children. This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving. The hierarchy summary field options: The following is a sample that shows how to configure the hierarchy summary fields: The Built-in Formulas The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy: CHILDREN This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent. If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents. ONLYCHILDREN This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents. PARENT This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record. If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved. LEVEL This formula is for retrieving the level of the current record. LEVELROWNUMBER This formula is for retrieving the row number of the current record under the parent scope.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; export function AppFunc() { const initSpread = (spread) => { spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.clearSheets(); var dataManager = spread.dataManager(); initHierarchyFormulas(spread, dataManager); } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread)}> </SpreadSheets> </div> </div> ); } function initHierarchyFormulas(spread, dataManager) { var table = dataManager.addTable("Table", { remote: { read: { url: getBaseApiUrl() + "/Hierarchy_Formula" } }, schema: { hierarchy: { type: 'Parent', column: 'parent', summaryFields: { 'budget': '=SUM(CHILDREN(1,"budget"))' } }, columns: { id: { isPrimaryKey: true, }, }, } }); var sheet = spread.addSheetTab(0, "HierarchyFormula", GC.Spread.Sheets.SheetType.tableSheet); sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader); sheet.options.allowAddNew = false; table.fetch().then(function () { var myView = table.addView("myView", [ { value: '=CONCAT([@department]," (L",LEVEL(),"-",LEVELROWNUMBER(),")")', caption: 'Department', width: 265, outlineColumn: true }, { value: "budget", width: 100, caption: 'Budget' }, { value: '=IF(LEVEL()=0,"",[@budget]/PARENT(1,"budget"))', width: 120, caption: 'Percentage', style: { formatter: '0.00%' } }, { value: "location", width: 100, caption: 'Location' }, { value: "phone", width: 150, caption: 'Phone' }, { value: "country", width: 100, caption: 'Country' }, ]); spread.suspendPaint(); sheet.setDataView(myView); spread.resumePaint(); }); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; export class App extends Component { render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}> </SpreadSheets> </div> </div> ); } initSpread(spread) { spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.clearSheets(); var dataManager = spread.dataManager(); initHierarchyFormulas(spread, dataManager); } } function initHierarchyFormulas(spread, dataManager) { var table = dataManager.addTable("Table", { remote: { read: { url: getBaseApiUrl() + "/Hierarchy_Formula" } }, schema: { hierarchy: { type: 'Parent', column: 'parent', summaryFields: { 'budget':'=SUM(CHILDREN(1,"budget"))' } }, columns: { id: { isPrimaryKey: true, }, }, } }); var sheet = spread.addSheetTab(0, "HierarchyFormula", GC.Spread.Sheets.SheetType.tableSheet); sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader); sheet.options.allowAddNew = false; table.fetch().then(function () { var myView = table.addView("myView", [ { value: '=CONCAT([@department]," (L",LEVEL(),"-",LEVELROWNUMBER(),")")', caption: 'Department', width: 265, outlineColumn: true }, { value: "budget", width: 100, caption: 'Budget' }, { value: '=IF(LEVEL()=0,"",[@budget]/PARENT(1,"budget"))', width: 120, caption: 'Percentage', style: { formatter: '0.00%' } }, { value: "location", width: 100, caption: 'Location' }, { value: "phone", width: 150, caption: 'Phone' }, { value: "country", width: 100, caption: 'Country' }, ]); spread.suspendPaint(); sheet.setDataView(myView); spread.resumePaint(); }); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

Formulas

TableSheet supports some built-in formulas that can be used with hierarchy data.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children.

This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving.

The hierarchy summary field options:

interface GC.Data.IDataSourceOption {
    //others options...
    schema?: {
        hierarchy: {
          summaryFields: GC.Data.IHierarchySummaryFieldCollection // define the formulas for the fields
          //others options...
        }
        //others options...
    }
}
interface GC.Data.IHierarchySummaryFieldCollection {
    [key: string]: string; // the key is the field name, and the value is the formula
}

The following is a sample that shows how to configure the hierarchy summary fields:

var table = dataManager.addTable("Table", {
    schema: {
        hierarchy: {
            type: 'Parent',
            column: 'parent',
            summaryFields: {
                'budget':'=SUM(CHILDREN(1,"budget"))'
            }
        },
        columns: {
            id: {
                isPrimaryKey: true,
            },
            budget: { dataType: 'number' }
        },
    }
});
var view = table.addView("View",[
    { value: "id" },
    { value: "budget" },
])

The Built-in Formulas

The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy:

CHILDREN

This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent.

If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents.

CHILDREN(levelOffset, fieldName)

ONLYCHILDREN

This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents.

ONLYCHILDREN(fieldName)

PARENT

This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record.

If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved.

PARENT(levelOffset, fieldName)

LEVEL

This formula is for retrieving the level of the current record.

LEVEL()

LEVELROWNUMBER

This formula is for retrieving the row number of the current record under the parent scope.

LEVELROWNUMBER()
When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children. This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving. The hierarchy summary field options: The following is a sample that shows how to configure the hierarchy summary fields: The Built-in Formulas The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy: CHILDREN This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent. If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents. ONLYCHILDREN This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents. PARENT This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record. If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved. LEVEL This formula is for retrieving the level of the current record. LEVELROWNUMBER This formula is for retrieving the row number of the current record under the parent scope.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { let spread = $event.spread; spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.clearSheets(); var dataManager = spread.dataManager(); initHierarchyFormulas(spread, dataManager); } } function initHierarchyFormulas(spread:GC.Spread.Sheets.Workbook, dataManager:any) { var table = dataManager.addTable("Table", { remote: { read: { url: getBaseApiUrl() + "/Hierarchy_Formula" } }, schema: { hierarchy: { type: 'Parent', column: 'parent', summaryFields: { 'budget':'=SUM(CHILDREN(1,"budget"))' } }, columns: { id: { isPrimaryKey: true, }, }, } }); var sheet = spread.addSheetTab(0, "HierarchyFormula", GC.Spread.Sheets.SheetType.tableSheet); sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader); sheet.options.allowAddNew = false; table.fetch().then(function () { var myView = table.addView("myView", [ { value: '=CONCAT([@department]," (L",LEVEL(),"-",LEVELROWNUMBER(),")")', caption: 'Department', width: 265, outlineColumn: true }, { value: "budget", width: 100, caption: 'Budget' }, { value: '=IF(LEVEL()=0,"",[@budget]/PARENT(1,"budget"))', width: 120, caption: 'Percentage', style: { formatter: '0.00%' } }, { value: "location", width: 100, caption: 'Location' }, { value: "phone", width: 150, caption: 'Phone' }, { value: "country", width: 100, caption: 'Country' }, ]); spread.suspendPaint(); sheet.setDataView(myView); spread.resumePaint(); }); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> </div>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Formulas

TableSheet supports some built-in formulas that can be used with hierarchy data.

Description
app.vue
index.html
Copy to CodeMine

When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children.

This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving.

The hierarchy summary field options:

interface GC.Data.IDataSourceOption {
    //others options...
    schema?: {
        hierarchy: {
          summaryFields: GC.Data.IHierarchySummaryFieldCollection // define the formulas for the fields
          //others options...
        }
        //others options...
    }
}
interface GC.Data.IHierarchySummaryFieldCollection {
    [key: string]: string; // the key is the field name, and the value is the formula
}

The following is a sample that shows how to configure the hierarchy summary fields:

var table = dataManager.addTable("Table", {
    schema: {
        hierarchy: {
            type: 'Parent',
            column: 'parent',
            summaryFields: {
                'budget':'=SUM(CHILDREN(1,"budget"))'
            }
        },
        columns: {
            id: {
                isPrimaryKey: true,
            },
            budget: { dataType: 'number' }
        },
    }
});
var view = table.addView("View",[
    { value: "id" },
    { value: "budget" },
])

The Built-in Formulas

The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy:

CHILDREN

This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent.

If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents.

CHILDREN(levelOffset, fieldName)

ONLYCHILDREN

This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents.

ONLYCHILDREN(fieldName)

PARENT

This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record.

If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved.

PARENT(levelOffset, fieldName)

LEVEL

This formula is for retrieving the level of the current record.

LEVEL()

LEVELROWNUMBER

This formula is for retrieving the row number of the current record under the parent scope.

LEVELROWNUMBER()
When the data source is hierarchical, a formula can be configured for data fields in the schema, and the formula only be invoked when the record has children. This means that the value for the parent record is summarized, and the value from the child record are in the same field when retrieving. The hierarchy summary field options: The following is a sample that shows how to configure the hierarchy summary fields: The Built-in Formulas The built-in formulas can be used in the hierarchy summary fields or in the calculation column when it’s in the hierarchy: CHILDREN This formula is for retrieving the value that is specified by the [fieldName] of the children that are [levelOffset] steps away from the parent. If the level offset is bigger than the interval between the current record and the lowest children, the values are from the children that are not parents. ONLYCHILDREN This formula is for retrieving the value that is specified by [fieldName] of the children that are not parents. PARENT This formula is for retrieving the value that is specified by [fieldName] of the parent that are [levelOffset] steps away from the current record. If the level offset is bigger than the interval between the current record and the highest parent, the value is from the highest parent. However if the current record is the highest parent, nothing will be retrieved. LEVEL This formula is for retrieving the level of the current record. LEVELROWNUMBER This formula is for retrieving the row number of the current record under the parent scope.
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; const spreadRef = ref(null); function initSpread(spread) { spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.clearSheets(); var dataManager = spread.dataManager(); initHierarchyFormulas(spread, dataManager); } function initHierarchyFormulas(spread, dataManager) { var table = dataManager.addTable("Table", { remote: { read: { url: getBaseApiUrl() + "/Hierarchy_Formula" } }, schema: { hierarchy: { type: 'Parent', column: 'parent', summaryFields: { 'budget': '=SUM(CHILDREN(1,"budget"))' } }, columns: { id: { isPrimaryKey: true, }, }, } }); var sheet = spread.addSheetTab(0, "HierarchyFormula", GC.Spread.Sheets.SheetType.tableSheet); sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader); sheet.options.allowAddNew = false; table.fetch().then(function () { var myView = table.addView("myView", [ { value: '=CONCAT([@department]," (L",LEVEL(),"-",LEVELROWNUMBER(),")")', caption: 'Department', width: 265, outlineColumn: true }, { value: "budget", width: 100, caption: 'Budget' }, { value: '=IF(LEVEL()=0,"",[@budget]/PARENT(1,"budget"))', width: 120, caption: 'Percentage', style: { formatter: '0.00%' } }, { value: "location", width: 100, caption: 'Location' }, { value: "phone", width: 150, caption: 'Phone' }, { value: "country", width: 100, caption: 'Country' }, ]); spread.suspendPaint(); sheet.setDataView(myView); spread.resumePaint(); }); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);